' Programm vergleicht Ausgangsspannung eines als Mikrofon eingesetzten Piezoschwingers
' mit der Spannung an einem Spannungsteiler. Nach einem Doppelimpuls (Doppelklatschen) 
' werden PortB.3 und PortB.4 für 90 Sekunden niederohmig geschaltet, um die NF kurz-
' zuschliessen.
' Compiler: BASCOM 2.0.7.5 Demo
'--------------------------------------------------------------------------------------


$regfile = "attiny13.dat"
$crystal = 1200000
$hwstack = 32
$swstack = 8
$framesize = 8

DIDR0 = &B00011111               ' alle Digitaleingänge deaktivieren

' Dies wäre die "offizielle" Bascom-Syntax für den Komparator:

' Config ACI = ON , COMPARE = ON
' Enable Interrupts
' Enable ACI


' so geht es mit direkter Register-Manipulation
ACSR.ACO = 1                     ' Output to IRQ ACO 
ACSR.ACIE = 1                    ' AC Interrupt Enable
SREG.7 = 1                       ' Interrupts enable
ACSR.ACD = 0                     ' AC Interrupt enable

' Alternative Komparatoreingänge wählt man so:
' ADCSRB.ACME = 1    ' Multiplexer enable
' ADMUX = 2          ' PinB.4 (ADC2) statt PinB.1
' ACSR.ACBG = 1      ' 1,1V Bandgap statt PinB.0 

Dim Aci_cntr As Byte
Dim Aci_cmp As Byte

On ACI on_aci                     ' Interrupt-Routine definieren


Do

   If Aci_cntr > 0 then           ' Interrupt(s) aufgetreten durch das erste Klatschen
      Waitms 100                  ' falls erstes Klatschen mehrere Interrupts erzeugt 
      Aci_cmp = Aci_cntr          ' Zahl der Interrupts zwischenspeichern  
      Waitms 300                  ' auf zweites klatschen warten 
      If Aci_cntr > Aci_cmp then  ' weitere Interrupts aufgetreten? 
         DDRB.3 = 1               ' Ausgänge niederohmig schalten
         DDRB.4 = 1
	     Wait 90                  ' muss ggf.verländert werden
         DDRB.3 = 0               ' Ausgänge hochohmig schalten
	     DDRB.4 = 0
      End If
      Aci_cntr = 0
   End If
   Idle                           ' Powerdown schaltet leider den Komparator ab
Loop


on_aci:
    Incr Aci_cntr
Return


End
